# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify Alma, CentOS, CentOS Stream and Rocky Linux as rhel
%if "%{__distinit}" == "a" || "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "cs" || "%{__distinit}" == "rl"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

%bcond_without network_tests

# I wish upstream would stick to version numbers with the same number of digits
%global cpanversion 1.168

Summary:	HTTP-SimpleLinkChecker module for perl 
Name:		perl-HTTP-SimpleLinkChecker
Version:	1.16.8
Release:	2.%{__distinit}%{__distvers}
License:	Artistic-2.0
URL:		https://metacpan.org/release/HTTP-SimpleLinkChecker
Source0:	https://cpan.metacpan.org/modules/by-module/HTTP/HTTP-SimpleLinkChecker-%{cpanversion}.tar.gz
Patch0:		HTTP-SimpleLinkChecker-1.168-links.patch
Patch1:		HTTP-SimpleLinkChecker-1.168-no-online-tests.patch
BuildArch:	noarch
# Module Build
BuildRequires:	coreutils
BuildRequires:	findutils
BuildRequires:	make
BuildRequires:	perl-generators
BuildRequires:	perl-interpreter >= 4:5.10.1
BuildRequires:	perl(ExtUtils::MakeMaker) >= 6.64
BuildRequires:	perl(File::Spec)
BuildRequires:	perl(File::Spec::Functions)
BuildRequires:	perl(Test::Manifest) >= 1.21
# Module Runtime
BuildRequires:	perl(Exporter)
BuildRequires:	perl(IO::Socket::SSL) >= 1.94
BuildRequires:	perl(Mojo::UserAgent) >= 4.50
BuildRequires:	perl(strict)
BuildRequires:	perl(vars)
BuildRequires:	perl(warnings)
# Script Runtime
BuildRequires:	perl(HTTP::Status)
# Test Suite
BuildRequires:	perl(Test::More) >= 1
# Optional tests
BuildRequires:	perl(Test::Pod) >= 1.00
BuildRequires:	perl(Test::Pod::Coverage)
# Dependencies
%if 0%{?fedora} < 38 && 0%{?rhel} < 10
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
%endif
Requires:	perl(IO::Socket::SSL) >= 1.94

%description
You don't have to know anything about objected-oriented Perl, LWP,
or the HTTP module to be able to check your links. This module is
designed for the casual user. It has one function, check_link,
that returns the HTTP response code that it receives when it tries
to fetch the web address passed to it. The undef value is returned
for any failure and the $HTTP::SimpleLinkChecker::ERROR variable is set.

The HEAD method is tried first, although if anything other than a
good status code (those less than 400) is received, another request
is made with the GET method.

%prep
%setup -q -n HTTP-SimpleLinkChecker-%{cpanversion}

# Use links that work for the test suite
%patch -P 0

# Implement option not to do tests that require external network access
%if !%{with network_tests}
%patch -P 1
%endif

%build
perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -delete
%{_fixperms} -c %{buildroot}

%check
make test

%files
%license LICENSE
%doc Changes README.pod
%{_bindir}/http_status
%dir %{perl_vendorlib}/HTTP/
%{perl_vendorlib}/HTTP/SimpleLinkChecker.pm
%{_mandir}/man1/http_status.1*
%{_mandir}/man3/HTTP::SimpleLinkChecker.3*

%changelog
* Mon Jul 17 2023 Paul Howarth <paul@city-fan.org> - 1.16.8-2
- Use SPDX-format license tag
- Avoid use of deprecated patch syntax

* Thu Feb  4 2021 Paul Howarth <paul@city-fan.org> - 1.16.8-1
- Update to 1.168
  - Note this is an abandoned module and update the Github address
- Switch upstream from search.cpan.org to metacpan.org
- Use %%license unconditionally

* Mon Apr 30 2018 Paul Howarth <paul@city-fan.org> - 1.16.7-1
- Update to 1.167
  - Clarify that it's the Artistic License 2.0
- BR: perl-generators unconditionally
- BR: perl-interpreter rather than perl
- License changed to Artistic 2.0

* Thu Jun 15 2017 Paul Howarth <paul@city-fan.org> - 1.16.5-2
- Add ability to disable at build-time the tests that require external network
  access (--without network_tests)

* Wed Dec  7 2016 Paul Howarth <paul@city-fan.org> - 1.16.5-1
- Update to 1.165
  - Allow the user agent to redirect a couple of times; if you don't like that,
    you can turn it off as documented
- Update link patch

* Thu Oct 13 2016 Paul Howarth <paul@city-fan.org> - 1.16.4-1
- Update to 1.164
  - Use Mojo::UserAgent for the underlying client
    (https://github.com/briandfoy/http-simplelinkchecker/issues/1)
- Update link patch, drop others
- Modernize spec since we now can only build from F-19 onwards due to the
  version requirement on Mojilicious

* Tue Aug  2 2016 Paul Howarth <paul@city-fan.org> - 1.16.3-2
- BR: perl-generators where available
- Avoid installing README.pod with old ExtUtils::MakeMaker versions
- Simplify find command using -delete

* Thu Jan 14 2016 Paul Howarth <paul@city-fan.org> - 1.16.3-1
- Update to 1.163
  - Handle HTTPS, now that LWP needs extra help
  - Fix prereq test (CPAN RT#111166)
  - Fix up MANIFEST
- Update links patch, supporting old versions of Test::More
- Add patch to support building with ExtUtils::MakeMaker < 6.64
- Add patch to support HTTPS with LWP::UserAgent < 6.00

* Mon Jun 22 2015 Paul Howarth <paul@city-fan.org> - 1.16-6
- Use links that work for the test suite
- Classify buildreqs by usage

* Tue Sep  2 2014 Paul Howarth <paul@city-fan.org> - 1.16-5
- Drop %%defattr, redundant since rpm 4.4
- Use %%license where possible

* Tue Jul  3 2012 Paul Howarth <paul@city-fan.org> - 1.16-4
- BR: perl(base), perl(ExtUtils::MakeMaker), perl(Test::Manifest) and
  perl(Test::More)
- Drop explicit perl(Exporter) runtime dependency, detected automatically
  from rpm 4.9, not needed prior to that as the module is bundled with perl
- Don't need to remove empty directories from the buildroot
- Drop support for old distributions prior to FC-3:
  - Don't need to define %%{perl_vendorlib}
  - Use DESTDIR rather than PERL_INSTALL_ROOT

* Mon Jun 27 2011 Paul Howarth <paul@city-fan.org> - 1.16-3
- Rebuild for perl 5.14.1 in Rawhide
- Use %%{_fixperms} macro rather than our own %%{__chmod} incantation
- Nobody else likes macros for commands
- Fix dist tag for CentOS 6 and Scientific Linux

* Fri Jun 25 2010 Paul Howarth <paul@city-fan.org> - 1.16-2
- Rebuild for perl 5.12.1 in Rawhide

* Mon May 24 2010 Paul Howarth <paul@city-fan.org> - 1.16-1
- Update to 1.16 (fix 403 status test - CPAN RT#57584)
- Drop patch for 403.t, no longer needed

* Thu May 13 2010 Paul Howarth <paul@city-fan.org> - 1.15-5
- Fix dist tag for RHEL-6 Beta
- Add patch for 403.t to use a working URL

* Fri Feb 12 2010 Paul Howarth <paul@city-fan.org> - 1.15-4
- Drop explicit perl-libwww-perl dep and req/buildreq specific perl modules
- BR/Req perl(Exporter), used in "use base" clause
- Dist tag for Rawhide no longer needs special-casing

* Thu Jun 25 2009 Paul Howarth <paul@city-fan.org> - 1.15-3
- Define RPM macros in global scope

* Tue Mar 11 2008 Paul Howarth <paul@city-fan.org> - 1.15-2
- Rebuild for perl 5.10.0 on Fedora 9

* Mon Dec 10 2007 Paul Howarth <paul@city-fan.org> - 1.15-1
- Update to 1.15
- httpstatus renamed to http_status

* Tue Nov 27 2007 Paul Howarth <paul@city-fan.org> - 1.14-1
- Update to 1.14
- Add binary and manpage for httpstatus

* Wed Nov  7 2007 Paul Howarth <paul@city-fan.org> - 1.13-2
- Fix dist tag for Fedora 7 onwards
- Clarify license as GPL version 1 or later, or Artistic (i.e. same as perl)

* Wed Jan 10 2007 Paul Howarth <paul@city-fan.org> - 1.13-1
- Update to 1.13
- Include LICENSE file

* Tue Jan  2 2007 Paul Howarth <paul@city-fan.org> - 1.11-1
- Update to 1.11
- Fix argument order for find with -depth
- Add buildreqs perl(Test::Pod) and perl(Test::Pod::Coverage) for better test cover

* Fri Sep  1 2006 Paul Howarth <paul@city-fan.org> - 1.10-2
- Fix distribution tags for development releases
- Use search.cpan.org URL

* Thu Jun  8 2006 Paul Howarth <paul@city-fan.org> - 1.10-1
- Update to 1.10
- Simplify distribution-detection code
- Define %%{__id_u} in a more portable way
- Remove macros %%{__perl_package} and %%{__perl_version}
- Remove buildroot unconditionally in %%clean and %%install
- Don't use macros in command paths, hardcode them instead
- Add Test::Prereq as an additional buildreq for improved test cover

* Fri Jul  8 2005 Paul Howarth <paul@city-fan.org> - 1.09-1
- Update to 1.09
- Rewrite spec file in (mainly) Fedora Extras style
- Include full URL for source
- Fix URL
- Use MODULE_COMPAT dependency style and remove explicit perl dependency
- Remove MANIFEST from %%doc

* Fri Apr  1 2005 Paul Howarth <paul@city-fan.org> - 1.08-1
- Update to 1.08

* Wed Feb  9 2005 Paul Howarth <paul@city-fan.org> - 1.07-1
- Update to 1.07

* Wed Oct 27 2004 Paul Howarth <paul@city-fan.org> - 1.06-1
- Update to 1.06
- Tidy up spec file

* Mon May 10 2004 Paul Howarth <paul@city-fan.org> - 1.04-1
- Initial build
